/***************************************************************************
                          chatclient.cpp  -  description
                             -------------------
    begin                : Mit Apr 18 11:16:39 CEST 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "chatclient.h"
#include <iostream.h>
#include <stdio.h>
#include <unistd.h>

ChatClient::ChatClient(QString host) : KMainWindow()
{
 resize(600, 575);
 KSimpleConfig conf("kchatrc");
 conf.setGroup("Client");
 if (host == "@")
   m_remoteHost = conf.readEntry("Server", "");
 else
   m_remoteHost = host;
 QStringList hosts;
 for (int i = 0;conf.hasKey(QString("Server%1").arg(i));i++)
   hosts << conf.readEntry(QString("Server%1").arg(i), "");
 m_port = conf.readNumEntry("Port", 2000);
 view = new ChatClientView(m_remoteHost, hosts, m_port, this);
 setCentralWidget(view);

 downloadDialog = new DownloadDialog(this);
 uploadDialog = new UploadDialog(this);

 socket = new QSocket();
 connected = false;

 FILE *pipe;
 pipe = popen ("echo $LOGNAME", "r");
 char ch;
 while ((ch = fgetc(pipe)) != '\n')
   m_username += ch;
 pclose (pipe);
 char localhost[256];
 gethostname(localhost, 256);
 m_localHost = localhost;

 KStdAction::quit (this, SLOT(fileQuit()), actionCollection());

 KStdAction::configureToolbars (this, SLOT(configToolBar()), actionCollection());

 KStdAction::preferences (this, SLOT(preferences()), actionCollection());

// KStdAction::keyBindings(this, SLOT(slotKeyBindings()), actionCollection());

// new KAction (i18n("Sh&ortcuts"), "keyboard", Qt::CTRL + Qt::Key_O,
//              this, SLOT (slotShortcut()),
//              actionCollection(), "settings_shortcuts");

 saveChatAction = KStdAction::save (this, SLOT(saveChat()), actionCollection());

 connectAction = new KAction (i18n("Co&nnect"), "connect_creating", Qt::CTRL + Qt::Key_N,
                              view, SLOT (connectServer()),
                              actionCollection(), "connection_connect");
 disconnectAction = new KAction (i18n("&Disconnect"), "connect_no", Qt::CTRL + Qt::Key_D,
                                 view, SLOT (disconnectServer()),
                                 actionCollection(), "connection_disconnect");
 disconnectAction->setEnabled(false);
 chaterInformationAction = new KAction (i18n("&Information"), "idea", Qt::CTRL + Qt::Key_I,
                                        this, SLOT (information()),
                                        actionCollection(), "chatter_information");
 chaterInformationAction->setEnabled(false);

 chaterBeep = new KAction (i18n("&Beep"), "bell", Qt::CTRL + Qt::Key_B,
                           this, SLOT (beepAll()),
                           actionCollection(), "chatter_beep");
 chaterBeep->setEnabled(false);

 cleanChatAction = new KAction (i18n("&Clean Chat"), "filenew", Qt::CTRL + Qt::Key_C,
                                view, SLOT (cleanChat()), actionCollection(), "clear_chat");

 uploadAction = new KAction (i18n("&Upload File"), "mail_send", Qt::CTRL + Qt::Key_U,
                             this, SLOT (slotUpload()), actionCollection(), "upload_file");
 uploadAction->setEnabled(false);

 downloadAction = new KAction (i18n("Do&wnload File"), "mail_get", Qt::CTRL + Qt::Key_W,
                               this, SLOT (slotDownload()), actionCollection(), "download_file");
 downloadAction->setEnabled(false);

 createGUI();

/*/ conf.setGroup("Shortcuts");
 for (int i = 0;conf.hasKey(QString("%1").arg(i));i++)
   {
    shortcutList.insertItem( QString("display_%1").arg(conf.readEntry(QString("%1").arg(i), "")),
                             conf.readEntry(QString("%1").arg(i), ""), "" );
    shortcutList.connectItem( conf.readEntry(QString("%1").arg(i), ""),
                      this, SLOT( slotDisplayShortcut() ) );
   }
 shortcutList.readSettings();
*/
 statusBar()->insertItem("", 1, 1);
 statusBar()->insertItem(i18n("Downloads: n/a"), 2, 0, true);
 statusText(i18n ("Not connected"));

 connect (socket, SIGNAL (error(int)),
          this, SLOT (error(int)));

 connect (socket, SIGNAL (readyRead()),
          this, SLOT (messagearrived()));

 connect (socket, SIGNAL (connected()),
          this, SLOT (connectedHost()));

 connect (socket, SIGNAL (connectionClosed()),
          this, SLOT (disconnected()));

 connect (view, SIGNAL (connectTo(QString, int)),
          this, SLOT (connectTo(QString, int)));

 connect (view, SIGNAL (disconnect()),
          this, SLOT (disconnect()));

 connect (view, SIGNAL (newMessage(QString)),
          this, SLOT (sendNewMessage(QString)));

 connect (this, SIGNAL (newMessage(QString)),
          view, SLOT (displayNewMessage(QString)));

 if(conf.readBoolEntry("AutoConnect", true) || host != "@")
   view->connectServer();
}

ChatClient::~ChatClient()
{
}

void ChatClient::error(int cause){
 QString error;
 int reconnect;
 statusText (i18n ("connection error"));
 disconnected();
 switch (cause)
   {
    case QSocket::ErrConnectionRefused: error = i18n ("Server refused Connection\n"
                                                      "Check the Port!");
                                        KMessageBox::information (this, error);
                                        break;
    case QSocket::ErrHostNotFound     : error = i18n ("Server not reachable\n"
                                                      "Check the Hostname");
                                        KMessageBox::information (this, error);
                                        break;
    case QSocket::ErrSocketRead       : error = i18n ("Error while reading socket\n"
                                                      "Do you want to try to reconnect?");
                                        reconnect = KMessageBox::questionYesNo (this, error);
                                        if (reconnect == KMessageBox::Yes)
                                          connectTo(m_remoteHost, m_port);
                                        break;
    default                           : break;
   }
}
/** Connection estabilished */
void ChatClient::connectedHost(){
 QString login;
 login += '@';
 login += m_username;
 login += '@';
 login += m_localHost;
 login += ":@";
 sendData(login);
 sendData(QString("@fileport"));
 sendData(QString("@downloads"));
 sendData(QString("@filenames"));
 connected = true;
 view->connected();
 connectAction->setEnabled(false);
 disconnectAction->setEnabled(true);
 chaterBeep->setEnabled(true);
 chaterInformationAction->setEnabled(true);
 uploadAction->setEnabled(true);
 statusText(i18n ("Connected %1 on port %2").arg(m_remoteHost).arg(m_port));
}

/** disconnects */
void ChatClient::disconnect(){
 connectAction->setEnabled(true);
 disconnectAction->setEnabled(false);
 statusText(i18n ("Disconnecting"));
 socket->close();
 while (socket->state() != QSocket::Idle)
   kapp->processEvents ();
 disconnected();
}

void ChatClient::disconnected(){
 connected = false;
 view->disconnected();
 Logins.clear();
 files.clear();
 downloadDialog->setFiles(QStringList());
 connectAction->setEnabled(true);
 disconnectAction->setEnabled(false);
 chaterBeep->setEnabled(false);
 chaterInformationAction->setEnabled(false);
 uploadAction->setEnabled(false);
 downloadAction->setEnabled(false);
 statusText(i18n ("Not connected"));
 statusBar()->changeItem(i18n("Downloads: n/a"), 2);
}

void ChatClient::messagearrived(){
 QString msg;
 while (socket->canReadLine())
   {
    msg = socket->readLine();
    msg.truncate (msg.length() - 1);
    if (msg.at(0) == '@')
      {
       if (msg.at(msg.find(':') + 1) == '@' && msg.contains(':'))
         {
          Chater* current = new Chater(msg.left(msg.find(':')).remove(0, 1));
          Logins.append(current);
          view->newChater(current->user());
         }
       else if (msg.at(msg.find(':') + 1) == '~')
         {
          Chater* current = new Chater(msg.left(msg.find(':')).remove(0, 1));
          Chater* cur;
          if ((m_username == current->user()) && (m_localHost == current->host()))
            {
             disconnect();
             QString sorry;
             sorry = i18n("Oh sorry,\nthey want talk with you!!! what have you done?");
             KMessageBox::information (this, sorry, i18n("You were pushed out"));
            }
          else
            {
             for(cur = Logins.first();cur != 0; cur = Logins.next())
               {
                if((cur->user() == current->user()) && (cur->host() == current->host()))
                  Logins.remove(cur);
               }
             view->removeChater(current->user());
            }
         }
       else if (msg.at(msg.find(':') + 1) == 'b')
         KApplication::beep();
       else if (msg.at(msg.find(':') + 1) == 'q')
         {
          QString msg;
          msg += '@';
          msg += m_username;
          msg += '@';
          msg += m_localHost;
          msg += ":answer";
          sendData(msg);
         }
       else if (msg.left(msg.find(' ')) == QString("@fileport"))
         {
          fport = (msg.right(msg.length() - msg.find(' ') - 1)).toInt();
         }
       else if (msg.left(msg.find(' ')) == QString("@downloads"))
         {
          statusBar()->changeItem(i18n("Downloads: %1").arg(msg.right(msg.length() - msg.find(' ') - 1)), 2);
          if ((msg.right(msg.length() - msg.find(' ') - 1)).toInt() > 0)
            downloadAction->setEnabled(true);
          else
            downloadAction->setEnabled(false);
         }
       else if (msg == QString("@clear"))
         {
          files.clear();
          QStringList list;
          downloadDialog->setFiles(list);
          sendData("@downloads");
          sendData("@filenames");
         }
       else if (msg.left(msg.find(' ')) == QString("@filename"))
         {
          QString rest = msg.right(msg.length() - (msg.find(' ') + 1));
          files.insert(rest.right(rest.length() - (rest.find('#') + 1)),
                       rest.left(rest.find('#')).toInt());
          QStringList list;
          QMap <QString, int>::Iterator it;
          for (it = files.begin(); it != files.end();++it)
            list << it.key();
          downloadDialog->setFiles(list);
         }
      }
    else
      emit newMessage(msg);
   }
}
/** connects host on port port */
void ChatClient::connectTo(QString host, int port){
 connectAction->setEnabled(false);
 disconnectAction->setEnabled(true);
 socket->connectToHost (host, port);
 m_remoteHost = host;
 m_port = port;
 statusText(i18n ("Connecting %1 on port %2").arg(m_remoteHost).arg(m_port));
}
/** No descriptions */
void ChatClient::sendNewMessage(QString msg){
 if (msg == "")
   {
    view->displayNewMessage(i18n("Please don't send this message again"));
    return;
   }
 QString tmp = m_username;
 tmp += '@';
 tmp += m_localHost;
 tmp += ": ";
 tmp += msg;
 sendData(tmp);
}
/** sends msg to the server */
void ChatClient::sendData(QString msg){
 msg += '\n';
 socket->writeBlock(msg.ascii(), msg.length());
}
/** No descriptions */
bool ChatClient::queryClose(){
 return saveProperties();
}
/** No descriptions */
bool ChatClient::saveProperties(){
 KSimpleConfig conf("kchatrc");
 conf.setGroup("Client");
 if(conf.readBoolEntry("remember", true))
   {
    conf.writeEntry("Server", m_remoteHost);
    conf.writeEntry("Port", m_port);
   }
 return true;
}
/** No descriptions */
void ChatClient::fileQuit(){
 kapp->quit();
}
/** No descriptions */
void ChatClient::configToolBar(){
 KEditToolbar dialog (actionCollection());
 if (dialog.exec())
   createGUI();
}
/** gives information about a other chater */
void ChatClient::information(){
 Chater* current;
 QString text = i18n("User: %1\nHost: %2");
 for(current = Logins.first();current != 0; current = Logins.next())
   {
    if (current->user() == view->getCurrentText())
      {
       KMessageBox::information (this, text.arg(current->user()).arg(current->host()));
       break;
      }
   }
}
/** configure the preferences */
void ChatClient::preferences(){
 kcmchat * dialog = new kcmchat(this, "Preferences", true);
 dialog->exec();
}
/** No descriptions */
void ChatClient::beepAll(){
 QString tmp = "";
 tmp += '@';
 tmp += m_username;
 tmp += '@';
 tmp += m_localHost;
 tmp += ":b";
 sendData(tmp);
}
void ChatClient::saveChat(){
 KURL url;
 url = KFileDialog::getSaveURL ();
 if (url.isEmpty())
   return;
 if (url.isMalformed())
   {
    QString text = i18n("The URL %1 is not correct!");
    KMessageBox::sorry (this, text.arg(url.prettyURL()));
    return;
   }
 if (url.isLocalFile())
   {
    QFile file(url.path());
    file.open(IO_WriteOnly);
    saveToLocalFile (&file);
   }
 else
   {
    KTempFile tempfile;
    saveToLocalFile (tempfile.file());
    if (!KIO::NetAccess::upload (tempfile.name(), url))
      {
       QString text = i18n("Error uploading %1");
       KMessageBox::sorry (this, text.arg(url.prettyURL()));
       tempfile.unlink();
       return;
      }
    tempfile.unlink();
   }
}
/** saves the file */
void ChatClient::saveToLocalFile(QFile *file){
 QString text;
 text = i18n("Chat-protocol of ");
 text += KGlobal::locale()->formatDateTime (QDateTime::currentDateTime(), false, true);
 text += '\n';
 text += view->ChatText();
 QTextStream stream (file);
 stream.setEncoding(QTextStream::Latin1);
 stream << text;
 file->close();
}
/** calls the shortcuts dialog */
void ChatClient::slotShortcut(){
/* KSimpleConfig conf("kchatrc");
 ShortcutDialog* dialog = new ShortcutDialog(this);
 if (dialog->exec() == QDialog::Accepted)
   {
//    KAction* a;
    QStringList list = dialog->definedShortcuts();
    for ( int i = 0, QStringList::Iterator it = list.begin(); it != list.end(); ++it, i++ )
      {
       shortcutList.insertItem( QString("display_%1").arg(*it),
                                (*it), "" );
       shortcutList.connectItem( (*it), ""),
                                 this, SLOT( slotDisplayShortcut() ) );
       conf.setGroup("shortcuts");
       conf.writeEntry(QString("%1").arg(i), (*it));
/ *a = new KAction(i18n("Display \"%1\"").arg(*it), 0, 0,
                       this, SLOT (slotDisplayShortcut()),
                       0, QString("display_%1").arg(*it));* /
      }
    KKeyDialog::configureKeys( &shortcutList );
   }                              */
}
/** calls the keybinding dialog */
void ChatClient::slotKeyBindings(){
 KKeyDialog::configureKeys(actionCollection(), xmlFile());
 createGUI();
}
/** slot called when a shortcut should be send */
void ChatClient::slotDisplayShortcut(){
 if(sender() != 0)
   {
    cerr << sender()->name();
   }
}
/** No descriptions */
void ChatClient::statusText(QString text){
 statusBar()->changeItem(text, 1);
}
/** No descriptions */
void ChatClient::slotUpload(){
 uploadDialog->clear();
 if (uploadDialog->exec() == QDialog::Accepted)
   {
    if (!QFile::exists(uploadDialog->filename()))
      {
       KMessageBox::sorry(this,
        i18n("Sorry the file %1 does not exist.").arg(uploadDialog->filename()),
        i18n("File does not exist"));
       return;
      }
    QFile* file = new QFile(uploadDialog->filename());

    if (!fport || !connected)
      return;
    new FileSocket(fport, m_remoteHost, file, FileSocket::Upload, 0, this);
   }
}
/** No descriptions */
void ChatClient::slotDownload(){
 if (downloadDialog->exec() == QDialog::Accepted)
   {
    int filenumber;
    QMap <QString, int>::Iterator it;
    it = files.find(downloadDialog->filename());
    if (it == files.end())
      return;
    filenumber = it.data();
    KURL url;
    url = KFileDialog::getSaveURL ();
    if (url.isEmpty())
      return;
    if (url.isMalformed())
      {
       QString text = i18n("The URL %1 is not correct!");
       KMessageBox::sorry (this, text.arg(url.prettyURL()));
       return;
      }
    if (url.isLocalFile())
      {
       QFile* file = new QFile(url.path());
       new FileSocket(fport, m_remoteHost, file, FileSocket::Download, filenumber, this);
      }
    else
      {
       KTempFile tempfile;
       new FileSocket(fport, m_remoteHost, tempfile.file(), FileSocket::Download, filenumber, this);
       if (!KIO::NetAccess::upload (tempfile.name(), url))
         {
          QString text = i18n("Error uploading %1");
          KMessageBox::sorry (this, text.arg(url.prettyURL()));
          tempfile.unlink();
          return;
         }
       tempfile.unlink();
      }
   }
}
