/***************************************************************************
                          chatclient.h  -  description
                             -------------------
    begin                : Mit Apr 18 11:16:39 CEST 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHATCLIENT_H
#define CHATCLIENT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <qstring.h>
#include <qsocket.h>
#include <qprogressbar.h>
#include <klocale.h>
#include <stdlib.h>
#include <qlist.h>
#include <iostream.h>
#include <ksimpleconfig.h>
#include <kstdaction.h>
#include <kaction.h>
#include <kedittoolbar.h>
#include <kfiledialog.h>
#include <kio/netaccess.h>
#include <ktempfile.h>
#include <kkeydialog.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qdatetime.h>

#include "chater.h"
#include "chatclientview.h"
#include "kcmchat.h"
#include "shortcutdialog.h"
#include "downloaddialog.h"
#include "uploaddialog.h"
#include "filesocket.h"

/** ChatClient is the base class of the porject */
class ChatClient : public KMainWindow
{
  Q_OBJECT 
  public:
    /** construtor */
    ChatClient(QString host);
    /** destructor */
    ~ChatClient();
  /** No descriptions */
  public slots: // Public slots
    /** connects host on port port */
    void connectTo(QString host, int port);
    /** disconnects */
    void disconnect();
  /** No descriptions */
  void slotDownload();

  signals: // Signals
    /** No descriptions */
    void newMessage(QString msg);

  protected: // Protected methods
    /** No descriptions */
    bool queryClose();

  private:
    void saveToLocalFile(QFile *file);
    void statusText(QString text);

    ChatClientView *view;
    DownloadDialog* downloadDialog;
    UploadDialog* uploadDialog;

    int fport;
    QMap <QString, int> files;

    QSocket* socket;
    bool connected;
    QString m_remoteHost;
    int m_port;
    QString m_localHost;
    QString m_username;
    QList <Chater> Logins;
    /** sends msg to the server */
    void sendData(QString msg);
    bool saveProperties();

    KAction* connectAction;
    KAction* disconnectAction;
    KAction* chaterInformationAction;
    KAction* chaterBeep;
    KAction* saveChatAction;
    KAction* cleanChatAction;
    KAction* uploadAction;
    KAction* downloadAction;
//    KAccel shortcutList;

  private slots:
    void error(int cause);
    void connectedHost();
    void disconnected();
    void messagearrived();
    void sendNewMessage(QString msg);
    void configToolBar();
    void fileQuit();
    /** gives information about a other chater */
    void information();
    /** configure the prefereces */
    void preferences();
    void beepAll();
    /** calls the shortcuts dialog */
    void slotShortcut();
    void saveChat();
    /** calls the keybinding dialog */
    void slotKeyBindings();
    /** slot called when a shortcut should be send */
    void slotDisplayShortcut();
    void slotUpload();
};

#endif
