/***************************************************************************
                          filesocket.h  -  description
                             -------------------
    begin                : Thu Jan 3 2002
    copyright            : (C) 2002 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FILESOCKET_H
#define FILESOCKET_H

#include <qwidget.h>
#include <qsocket.h>
#include <qfile.h>
#include <qtimer.h>
#include <qprogressdialog.h>
#include <klocale.h>

/**the FileSocket handles the file up and download
  *@author Emanuel Schmieg
  */

class FileSocket : public QSocket  {
   Q_OBJECT
public: 
	enum Mode{Upload, Download};
	enum OwnError{ServerError, Refused, Unknown};
	FileSocket(int port, QString server, QFile* f, Mode transMode, int fnumber, QObject *parent=0, const char *name=0);
	~FileSocket();

public slots: // Public slots
  /** delete the socket not beautifull but usefull */
  void deleteMyself();

protected:
  void timerEvent(QTimerEvent*);

private:
  // Private methods
  void sendData(QString data);
  /** No descriptions */
  void errorHandler(int error, bool mine);

  QProgressDialog* pDialog;

  QFile* file;
  Mode transferMode;
  int filenumber;
  int bytes;
  int packets;
  int fullsteps;

private slots: // Public slots
  void readSocket();
  void connectedServer();
  void failed(int error);
};

#endif
