/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mit Apr 18 11:16:39 CEST 2001
    copyright            : (C) 2001 by Emanuel Schmieg
    email                : kerneld@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "chatclient.h"

static const char *description =
	I18N_NOOP("ChatClient");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
	
	
static KCmdLineOptions options[] =
{
  { "c", 0, 0 },
  { "connect <host>", I18N_NOOP("Connect to this host"), 0},
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main(int argc, char *argv[])
{

  KAboutData aboutData( "chatclient", I18N_NOOP("ChatClient"),
    VERSION, description, KAboutData::License_GPL,
    "(c) 2001, Emanuel Schmieg", 0, 0, "kerneld@gmx.net");
  aboutData.addAuthor("Emanuel Schmieg",0, "kerneld@gmx.net");
  KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.

  KApplication a;
  KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  QString host;
  if (args->isSet("connect"))
    host = args->getOption("connect");
  else
    host = "@";
  ChatClient *chatclient = new ChatClient(host);
  a.setMainWidget(chatclient);
  chatclient->show();  

  return a.exec();
}
